package com.steerinfo.dil.feign;

import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/1 17:19
 */

@FeignClient(name = "dil-trick-queue-dev", url = "${openfeign.QmsTruckFeign.url}")
public interface QmsTruckFeign {

    /*
    QmsQueueResultController /  QmsQueueListController
     */

    @PostMapping("api/v1/queueTruck/qmsqueueresults/addQueueResult")
    public Map<String, Object> addQueueResult(@RequestBody(required = false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueuelists/addQueueList")
    public Map<String, Object> addQueueList(@RequestBody(required = false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/orderReceive")
    public Map<String, Object> orderReceive(@RequestBody(required=false) Map<String,Object> mapValue,
                                            @RequestParam("apiId") Integer apiId,
                                            @RequestParam("pageNum") Integer pageNum,
                                            @RequestParam("pageSize") Integer pageSize,
                                            @RequestParam("queueType") Integer queueType,
                                            @RequestParam("con")String con
    );

    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueApply")
    public Map<String, Object> getQueueApply(@RequestBody(required=false) Map<String,Object> mapValue,
                                             @RequestParam("apiId") Integer apiId,
                                             @RequestParam("pageNum") Integer pageNum,
                                             @RequestParam("pageSize") Integer pageSize,
                                             @RequestParam("con")String con
    );

    @PostMapping("api/v1/queueTruck/qmsqueueresults/getAllQueueMes")
    public Map<String, Object> getAllQueueMes(@RequestBody(required=false) Map<String,Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize,
                                              @RequestParam("gatepostId") Integer gatepostId,
                                              @RequestParam("con")String con
    );

    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueListByQueueUp")
    public Map<String, Object> getQueueListByQueueUp(@RequestBody(required=false) Map<String,Object> mapValue,
                                                     @RequestParam("apiId") Integer apiId,
                                                     @RequestParam("pageNum") Integer pageNum,
                                                     @RequestParam("pageSize") Integer pageSize,
                                                     @RequestParam("gridId") Integer gridId,
                                                     @RequestParam("con")String con
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/changeQueue")
    public Map<String, Object> changeQueue(@RequestBody(required=false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getChangeQueue")
    public Map<String, Object> getChangeQueue(@RequestBody(required=false) Map<String,Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize,
                                              @RequestParam("con")String con
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/queueCancel")
    public Map<String, Object> queueCancel(@RequestBody(required=false) Map<String, Object> mapValue);



    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueCancel")
    public Map<String, Object> getQueueCancel(@RequestBody(required=false) Map<String,Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize,
                                              @RequestParam("con")String con

    );


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueCancelByResultId/{resultId}")
    public Map<String, Object> getQueueCancelByResultId(@PathVariable("resultId") Integer resultId);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/updateQueueCancel")
    public Map<String, Object> updateQueueCancel(@RequestBody(required=false) Map<String,Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueuelists/queueCutInLine")
    public Map<String, Object> queueCutInLine(@RequestBody(required=false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueInsert")
    public Map<String, Object> getQueueInsert(@RequestBody(required=false) Map<String,Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize,
                                              @RequestParam("con")String con
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/queueEndByPDA")
    public Map<String, Object> queueEnd(@RequestBody(required=false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueEndResult")
    public Map<String, Object> getQueueEndResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                                 @RequestParam("apiId") Integer apiId,
                                                 @RequestParam("pageNum") Integer pageNum,
                                                 @RequestParam("pageSize") Integer pageSize,
                                                 @RequestParam("con")String con
    );


    @PostMapping("api/v1/queueTruck/qmsqueueresults/capacityMonitor")
    public Map<String, Object> capacityMonitor(@RequestBody(required=false) Map<String,Object> mapValue,
                                               @RequestParam("apiId") Integer apiId,
                                               @RequestParam("pageNum") Integer pageNum,
                                               @RequestParam("pageSize") Integer pageSize,
                                               @RequestParam("gridType") Integer gridType,
                                               @RequestParam("con")String con
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/listMonitor")
    public Map<String, Object> listMonitor(@RequestBody(required=false) Map<String,Object> mapValue,
                                           @RequestParam("apiId") Integer apiId,
                                           @RequestParam("pageNum") Integer pageNum,
                                           @RequestParam("pageSize") Integer pageSize,
                                           @RequestParam("con")String con
    );



    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueStatusList")
    public Map<String, Object> getQueueStatusList();


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getOrderReceive/{capacityNumber}")
    public Map<String, Object> getOrderReceive(@PathVariable("capacityNumber") String capacityNumber);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/cancelQueue")
    public Map<String, Object> cancelQueue(@RequestBody Map<String,Object> mapValue);

    @PostMapping("api/v1/queueTruck/qmsqueueresults/getAllExecutionOrder")
    public Map<String, Object> getAllExecutionOrder(@RequestBody(required=false) Map<String,Object> mapValue,
                                                    @RequestParam("apiId") Integer apiId,
                                                    @RequestParam("pageNum") Integer pageNum,
                                                    @RequestParam("pageSize") Integer pageSize,
                                                    @RequestParam("orderType")Integer orderType,
                                                    @RequestParam("status")Integer status,
                                                    @RequestParam("con")String con
    );



    @PostMapping("api/v1/queueTruck/qmsqueuelists/getListQueueMes")
    RESTfulResult getListQueueMes(@RequestBody(required=false) Map<String, Object> mapValue);



    @PostMapping("api/v1/queueTruck/qmsqueueresults/getWarehouseQueueChange")
    Map<String, Object> getWarehouseQueueChange(@RequestBody(required=false) Map<String,Object> mapValue,
                                                @RequestParam("apiId") Integer apiId,
                                                @RequestParam("pageNum") Integer pageNum,
                                                @RequestParam("pageSize") Integer pageSize,
                                                @RequestParam("con")String con
    );
    @PostMapping("api/v1/queueTruck/qmsqueueresults/getWarehouseQueueEndMes")
    Map<String, Object> getWarehouseQueueEndMes(@RequestBody(required=false) Map<String,Object> mapValue,
                                                @RequestParam("apiId") Integer apiId,
                                                @RequestParam("pageNum") Integer pageNum,
                                                @RequestParam("pageSize") Integer pageSize,
                                                @RequestParam("con")String con
    );
}
