package com.steerinfo.dil.mapper;

import org.mapstruct.Mapper;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 通用接口
 * @ author    :TXF
 * @ time      :2021/10/19 18:03
 */

@Mapper
public interface UniversalMapper {
    //通过运输订单号查询订单信息
    Map<String, Object> getTiHuoDan(String orderNumber);

    //通过运输订单号查找订单子表物资信息
    List<Map<String, Object>> getOOMMes(String orderNumber);

    //模糊查询所有物资
    List<Map<String, Object>> queryAPOMaterialByLike(Map<String, Object> map);

    //模糊查询发货单位
    List<Map<String, Object>> querySupplierByLike(Map<String, Object> map);

    //模糊查询承运商的运力信息
    List<Map<String, Object>> getAllCapacityByCarrierLike(Map<String, Object> map);

    //通过运输订单ID查询物资子表（针对多拼）
    List<Map<String, Object>> getMaterialMesByOrderId(Map<String, Object> map);

    //通过订单ID查询订单下所有物资
    List<Map<String, Object>> getOrderMaterialMesByOrderId(BigDecimal orderId);

    //通过物资ID查询该物资的发货单位信息
    List<Map<String, Object>> getSupplierMesByMaterialId(Map<String, Object> map);

    //模糊查询所有的卸货点信息
    List<Map<String, Object>> getUnloadingMesByLike(Map<String, Object> map);

    //模糊查询所有物资
    List<Map<String, Object>> queryMaterialByLike(Map<String, Object> map);

    //查询所有的批次及其关联的采购订单号
    List<Map<String, Object>> getBatchAndOrderMes(Map<String, Object> map);

    //承运商边输边查
    List<Map<String, Object>> getCarrierMesByLike(String index);

    // 收货单位
    List<Map<String, Object>> queryConsigneeByLike(Map<String, Object> mapValue);

    // 所有物资
    List<Map<String, Object>> selectAllMaterialName(Map<String, Object> mapValue);

    // 所有承运商
    List<Map<String, Object>> getCarrierListByLike(Map<String, Object> mapValue);

    //边输边查卸货点
    List<Map<String, Object>> selectUnloadingPoint(String index);
}
