package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.DilVersionMapper;
import com.steerinfo.dil.model.DilVersion;
import com.steerinfo.dil.service.IDilVersionService;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;

/**
 * DilVersion服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-12-14 10:05
 * 类描述
 * 修订历史：
 * 日期：2021-12-14
 * 作者：generator
 * 参考：
 * 描述：DilVersion服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "dilVersionService")
public class DilVersionServiceImpl implements IDilVersionService {

    @Autowired
    private DilVersionMapper dilVersionMapper;


    /**
     * 传入版本号查询是否为最新版本
     * @return 0 不需要更新  1 需要更新
     */
    public String compareAppVersion(){
        //查找当前最新版本号
        return  dilVersionMapper.compareVersion();
    }

    /**
     * 添加APP版本号
     * @param version
     * @return
     */
    public String addAppVersion(String version){
        //判断该版本号是否已存在
        Integer versionId = dilVersionMapper.getVersionId(version);
        if(versionId != null){
            return "版本号已存在";
        }
        DilVersion dilVersion = new DilVersion();
        dilVersion.setVersionId(dilVersionMapper.selectMaxId());
        dilVersion.setVersionValue(version);
        dilVersion.setInsertTime(new Date());
        dilVersion.setInsertUsername("admin");
        dilVersionMapper.insertSelective(dilVersion);
        return version + "添加成功";
    }
}
